with gb; use gb;
with gb.OleInterfaces;

with Win32, Win32.WinDef, Win32.WinMain, Win32.WinUser, Win32.WinError, System;
with Win32.WinGDI, Win32.WinBase, Win32.WinNT, Win32.Utils, Interfaces.C;
use  Win32, Win32.WinError, Interfaces.C, System;

package Saisie_Nom is
  Form            : aliased gb.MainWindow;
  Validation      : aliased gb.Button;
  Prenom          : aliased gb.TextBox(Alignment => Left, AutoScroll => Both, 
                                       MultiLine => gb.False, Password => gb.False, 
                                       ReadOnly => gb.False);
  Label_Prenom    : aliased gb.Label;
  Nom             : aliased gb.TextBox(Alignment => Left, AutoScroll => Both, 
                                       MultiLine => gb.False, Password => gb.False, 
                                       ReadOnly => gb.False);
  Label_Nom       : aliased gb.Label;
  procedure Initialize_Form;
end Saisie_Nom;


package body Saisie_Nom is
  procedure Validation_Click is
  begin
  -- si le champ NOM est vide
  
            if text (Saisie_Nom.Nom) = "" then
  
            -- affiche un message derreur. 1er param. : Texte / 2eme param. : nom de la fentre
  
            MsgBox ("Le champ NOM est obligatoire", "Erreur");
  
            -- replace le curseur sur le champ  remplir
  
            SetFocus (Saisie_Nom.Nom);
  
  
            -- si le champ PRENOM est vide
  
            elsif text (Saisie_Nom.Prenom) = "" then
  
            -- affiche un message derreur 
  
            MsgBox ("Le champ PRENOM est obligatoire", "Erreur");
  
            -- replace le curseur sur le champ  remplir
  
            SetFocus (Saisie_Nom.Prenom);
  
  
            -- si les 2 champs sont remplis
  
            else
  
            gb.EndApplication;
  
            end if;
  
  end Validation_Click;

  procedure Prenom_Changed is
  begin
   -- si le champ de la boite de texte Saisie_Nom.Nom Contient plus de dix caractres 
  
            if text (Saisie_Nom.Prenom)'Length > 10 then
  
            -- message d'erreur
  
            MsgBox ("Maximum dix caractres !", " Erreur");
  
            -- recopie les 10 premiers caractres dans la mme fentre afin d'effacer le 11eme entr
  
            text (Saisie_Nom.Prenom, (text (Saisie_Nom.Prenom) (1..10)));
  
            end if;
  
  end Prenom_Changed;

  procedure Nom_Changed is
  begin
            -- si le champ de la boite de texte Saisie_Nom.Nom Contient plus de dix caractres 
  
            if text (Saisie_Nom.Nom)'Length > 10 then
  
            -- message derreur
  
            MsgBox ("Maximum dix caractres !", " Erreur");
  
            -- recopie les 10 premiers caractres dans la mme fentre afin deffacer le 11eme entr
  
            text (Saisie_Nom.Nom, (text (Saisie_Nom.Nom) (1..10)));
  
            end if;
  
  end Nom_Changed;

  procedure Initialize_Form is
  begin
    Validation.Click := Validation_Click'Access;
    Caption(Validation, "OK");
    Move(Validation, 120, 150, 91, 31);

    Prenom.Changed := Prenom_Changed'Access;
    Text(Prenom, "");
    Move(Prenom, 120, 80, 161, 31);

    Caption(Label_Prenom, "Prnom");
    Alignment(Label_Prenom, gb.Right);
    SetFont(Label_Prenom, "MS Sans Serif", 8, gb.False, gb.False, gb.False);
    Move(Label_Prenom, 30, 80, 61, 21);

    Nom.Changed := Nom_Changed'Access;
    Text(Nom, "");
    Move(Nom, 120, 20, 161, 31);

    Caption(Label_Nom, "Nom");
    Alignment(Label_Nom, gb.Right);
    SetFont(Label_Nom, "MS Sans Serif", 8, gb.False, gb.False, gb.False);
    Move(Label_Nom, 40, 30, 51, 21);

    Caption(Form, "Saisie du nom de l'utilisateur");
    ControlBox(Form, gb.False);
    MaxButton(Form, gb.False);
    MinButton(Form, gb.False);
    Move(Form, 171, 119, 334, 230);
    Visible(Form, gb.True);
  end Initialize_Form;
begin
  Initialize_Form;
end Saisie_Nom;


with gb;
with Saisie_Nom;

procedure Main is begin
  gb.StartApplication;
end Main;


